package fr.itsonus.bousoleplussbackend.repositories;

import fr.itsonus.bousoleplussbackend.models.Question;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.data.rest.core.annotation.RepositoryRestResource;
import org.springframework.data.rest.core.annotation.RestResource;
import org.springframework.stereotype.Repository;

@RepositoryRestResource
public interface QuestionRepository extends CrudRepository<Question, Long> {

    @RestResource(path="byAxeId", rel="byAxeId")
    @Query("SELECT q FROM Question q JOIN q.axe a WHERE q.axe.id = :id AND user_id = ?#{principal.id}")
    Iterable<Question> findAllByAxeId(@Param("id") final Long id);
}
