package fr.itsonus.bousoleplussbackend.repositories;

import fr.itsonus.bousoleplussbackend.models.Quiz;
import fr.itsonus.bousoleplussbackend.models.Response;
import fr.itsonus.bousoleplussbackend.projections.QuizWithResponses;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.data.rest.core.annotation.RepositoryRestResource;
import org.springframework.data.rest.core.annotation.RestResource;

import java.util.Set;

@RepositoryRestResource(excerptProjection = QuizWithResponses.class)
public interface QuizRepository extends PagingAndSortingRepository<Quiz, Long> {

    @RestResource(path = "me", rel = "me")
    @Query("SELECT q FROM Quiz q WHERE q.userId = ?#{principal.id}")
    Page<Quiz> findAllOfCurrentUser(final Pageable pageable);
}
